class Character {

  // Put name, personality, etc info in here too
  String name = "";

  // Holds the EmoBranch (where on the dial) and strength (how far in/out)
  EmoState state = new EmoState();

  // Used for detecting loading new image and probably other things in the future
  ArrayList hist = new ArrayList();

  // location for drawing
  int xpos = width/2;
  int ypos = height/2;
  int speed = 3;
  
  int collX;
  int collY;
  int wid;

  Character(String name) {
    this.name = name;
  }
  
  Character(String name, int x, int y) {
    this.name = name;
    xpos = x;
    ypos = y;
  }

  void saveState(){
    hist.add(state.copyCurrState());
  }
  //
  void setEmoState(EmoState estate) {
    //saveState("");
    state = estate.copyCurrState();
  }
  
  void setEmoState(int ID, String userText, int hap, int sad, int ang, int dis, int sur, int afr) {
    setEmoState(new EmoState(ID, userText, hap, sad, ang, dis, sur, afr));
  }
  
  void updateCharacter(){
    wid = 15 * state.emoSize;
    collX = xpos - ((state.emoSize * 15)/2);
    collY = ypos - ((state.emoSize * 15)/2);
    //if (name == "pc") println(xpos + " - " + (state.emoSize/2));
  }
  
  void drawCharacter(){
    /*
    noFill();
    stroke(255);
    rect(collX, collY, wid, wid);*/
    state.drawState(xpos, ypos);
  }
  
  Boolean checkColl(int oX, int oY, int oW, int oH){
    if (oX + oW < collX || oX > collX + wid || oY + oH < collY || oY > collY + wid){
      return false;
    } else {
      return true;
    }
  }

}

