/*
Happy :) =) :D =D (: (= C: C= ^.^ ^_^ :P
 Sad :( =( D= D: ): )= T.T
 Angry >=( >=O >=o O=< )=< 
 Disgusted >=[ >=C D=< >:[ >:C D:< o_O :< >:
 Surprised :O =O :0 =0 :o =o o.o O.O
 Afraid ={ <.< >.> :{ X.X x.x o_o X_X x_x
 
 */

Character targetC = null;

void parseInput() {
  println("parsing... " + workingEmoticon);
  if (workingEmoticon != "" && targetC != null) {
    String te = "";
    // remove white space
    for (int i = 0; i < workingEmoticon.length(); i++) {
      char c = workingEmoticon.charAt(i);
      if (c != ' ' && c != CODED) te += c;
    }
    println("Trimmed input at length " + te.length() + ": " + te);

    int emotionHit = -1;
    /*
    Boolean eyesDetect = false; // : or =
     Boolean openPara = false; // ( could be frown or smile depending
     Boolean closePara = false; // )
     Boolean dMouth = false; // D could be positve or negative
     Boolean cMouth = false; // C could be positive or negative
     Boolean pMouth = false; // P probably happy
     Boolean pointEyes = false; // ^ probably happy
     Boolean tearEyes = false; // T probably sad
     Boolean greaterT = false; // > angry or disgusted face
     Boolean lessT = false; // < angry or disgusted face
     Boolean oh = false; // "o" key, eye or mouth
     Boolean oH = false; // "O" capital "o"
     Boolean zero = false; // 0 number
     
     
     for (int i = 0; i < trimEmoticon.length(); i++){
     if (emotionHit == -1){
     char c = trimEmoticon.charAt(i);
     if (c == ':' || c == '='){ 
     // Keep eyes simple: seeing them doesn't necessarily means something is done
     eyesDetect = true;
     } else if (c == '('){ 
     openPara = true;
     if (eyesDetect == true) emotionHit = 1; // if Eyes come before mouth, we have hit sadness =(
     else emotionHit = 0; // Else, mouth comes first (:
     } else if (c == ')'){ 
     closePara = true;
     // if Eyes come before mouth, we have hit happiness =)
     if (eyesDetect == true) emotionHit = 0;
     } else if (c == 'D'){ dMouth = true;
     // if Eyes come before mouth, we have hit happiness =D
     if (eyesDetect == true) emotionHit = 0;
     else emotionHit = 1; // Else, mouth comes first D:
     } else if (c == 'C'){ cMouth = true;
     } else if (c == 'P'){ pMouth = true;
     } else if (c == '^'){ pointEyes = true;
     } else if (c == 'T'){ tearEyes = true;
     } else if (c == '>'){ greaterT = true;
     } else if (c == '<'){ lessT = true;
     } else if (c == 'o'){ oh = true;
     } else if (c == 'O'){ oH = true;
     } else if (c == '0'){ zero = true;
     }
     }*/

    if (te.compareTo(":)") == 0 || te.compareTo("=)") == 0 || te.compareTo(":D") == 0 || te.compareTo("=D") == 0 || te.compareTo("(:") == 0 ||
      te.compareTo("(=") == 0 || te.compareTo("C:") == 0 || te.compareTo("C=") == 0 || te.compareTo("^.^") == 0 || te.compareTo("^_^") == 0 || te.compareTo(":P") == 0 ||
      te.compareTo(":-)") == 0 || te.compareTo("=-)") == 0 || te.compareTo(":-D") == 0 || te.compareTo("=-D") == 0 || te.compareTo("(-:") == 0 ||
      te.compareTo("(-=") == 0 || te.compareTo("C-:") == 0 || te.compareTo("C-=") == 0 || te.compareTo(":-P") == 0) 
      emotionHit = 0;
    else if (te.compareTo(":(") == 0 || te.compareTo("=(") == 0 || te.compareTo("D=") == 0 || te.compareTo("D:") == 0 || 
      te.compareTo("):") == 0 || te.compareTo(")=") == 0 || te.compareTo("T.T") == 0 ||
      te.compareTo(":'(") == 0 || te.compareTo("='(") == 0 || te.compareTo("D'=") == 0 || te.compareTo("D':") == 0 || 
      te.compareTo(")':") == 0 || te.compareTo(")'=") == 0 ||
      te.compareTo(":,(") == 0 || te.compareTo("=,(") == 0 || te.compareTo("D,=") == 0 || te.compareTo("D,:") == 0 || 
      te.compareTo("),:") == 0 || te.compareTo("),=") == 0 ||
      te.compareTo(":.(") == 0 || te.compareTo("=.(") == 0 || te.compareTo("D.=") == 0 || te.compareTo("D.:") == 0 || 
      te.compareTo(").:") == 0 || te.compareTo(").=") == 0 ||
      te.compareTo(":-(") == 0 || te.compareTo("=-(") == 0 || te.compareTo("D-=") == 0 || te.compareTo("D-:") == 0 || 
      te.compareTo(")-:") == 0 || te.compareTo(")-=") == 0) 
      emotionHit = 1;
    else if (te.compareTo(">=(") == 0 || te.compareTo(">=O") == 0 || te.compareTo(">=o") == 0 || te.compareTo("O=<") == 0 || te.compareTo(")=<") == 0 ||
      te.compareTo(">=-(") == 0 || te.compareTo(">=-O") == 0 || te.compareTo(">=-o") == 0 || te.compareTo("O-=<") == 0 || te.compareTo(")-=<") == 0 ||
      te.compareTo(">:(") == 0 || te.compareTo(">:O") == 0 || te.compareTo(">:o") == 0 || te.compareTo("O:<") == 0 || te.compareTo("):<") == 0 ||
      te.compareTo(">:-(") == 0 || te.compareTo(">:-O") == 0 || te.compareTo(">:-o") == 0 || te.compareTo("O-:<") == 0 || te.compareTo(")-:<") == 0)
      emotionHit = 2;
    else if (te.compareTo(">=[") == 0 || te.compareTo(">=C") == 0 || te.compareTo("D=<") == 0 || 
      te.compareTo(">:[") == 0 || te.compareTo("]=<") == 0 || te.compareTo("]:<") == 0 ||
      te.compareTo(">:C") == 0 || te.compareTo("D:<") == 0 || te.compareTo("o_O") == 0 || 
      te.compareTo("O_o") == 0 || te.compareTo(":<") == 0 || te.compareTo(">:") == 0 || 
      te.compareTo("=<") == 0 || te.compareTo(">=") == 0 ||
      te.compareTo(">=-[") == 0 || te.compareTo(">=-C") == 0 || te.compareTo("D-=<") == 0 || 
      te.compareTo(">:-[") == 0 || te.compareTo("]-=<") == 0 || te.compareTo("]-:<") == 0 ||
      te.compareTo(">:-C") == 0 || te.compareTo("D-:<") == 0 || te.compareTo(":-<") == 0 || 
      te.compareTo(">-:") == 0 || te.compareTo("=-<") == 0 || te.compareTo(">-=") == 0)
      emotionHit = 3;
    else if (te.compareTo(":O") == 0 || te.compareTo("=O") == 0 || te.compareTo(":0") == 0 || te.compareTo("=0") == 0 ||
      te.compareTo(":o") == 0 || te.compareTo("=o") == 0 || te.compareTo("o.o") == 0 || te.compareTo("O.O") == 0 ||
      te.compareTo("O:") == 0 || te.compareTo("O=") == 0 || te.compareTo("0:") == 0 || 
      te.compareTo("0=") == 0 || te.compareTo("o:") == 0 || te.compareTo("o=") == 0 ||
      te.compareTo(":-O") == 0 || te.compareTo("=-O") == 0 || te.compareTo(":-0") == 0 || 
      te.compareTo("=-0") == 0 || te.compareTo(":-o") == 0 || te.compareTo("=-o") == 0 ||
      te.compareTo("O-:") == 0 || te.compareTo("O-=") == 0 || te.compareTo("0-:") == 0 || 
      te.compareTo("0-=") == 0 || te.compareTo("o-:") == 0 || te.compareTo("o-=") == 0)
      emotionHit = 4;
    else if (te.compareTo("={") == 0 || te.compareTo("}=") == 0 || te.compareTo("<.<") == 0 || 
      te.compareTo(">.>") == 0 || te.compareTo(":{") == 0 || te.compareTo("}:") == 0 ||
      te.compareTo("X.X") == 0 || te.compareTo("x.x") == 0 || te.compareTo("o_o") == 0 || te.compareTo("X_X") == 0 || te.compareTo("x_x") == 0 ||
      te.compareTo("=-{") == 0 || te.compareTo("}-=") == 0 || te.compareTo(":-{") == 0 || te.compareTo("}-:") == 0)
      emotionHit = 5;

    if (emotionHit != -1) {
      println("EMOTION DETECTED: " + emotionHit);
      targetC.saveState();
      for (int i = 0; i < targetC.state.emotions.length; i++) {
        if (i == emotionHit && targetC.state.emotions[i] < 5) {
          println("++ to emotion " + i + " for a total of " + (targetC.state.emotions[i]+1));
          targetC.state.emotions[i]++;
        } 
        else if (i != emotionHit && targetC.state.emotions[i] > 1) {
          
          int rand = (int) random(2) + 1;
          if (rand == 1) {
            targetC.state.emotions[i]--;
            println("RANDOM -- to emotion " + i + " for a total of " + (targetC.state.emotions[i]+1));
          }
          else {
            println("NO -- to emotion " + i + " for a total of " + (targetC.state.emotions[i]+1));
          }
        }
      }
      targetC.setEmoState(targetC.state.id, workingEmoticon, targetC.state.emotions[0], 
      targetC.state.emotions[1], targetC.state.emotions[2], targetC.state.emotions[3], 
      targetC.state.emotions[4], targetC.state.emotions[5]);
    }
    else {
      println("EMOTIONMISSED" + (workingEmoticon.compareTo(":)")) + "!!!!!!!!!!!!!");
    }
  }
}

